#!/usr/bin/python
#
# Author Walter R.P. Novak, Wabash College
# August 31, 2011
#
# pdb_mod2chain.py - takes the biologically relevant pdb form, which includes model records instead of chains, and 
# 		     converts the models into chains.
#
# just feed it the pdb file with mutliple models on the command line and it outputs a file ending in .chains
#
# Copyright (C) 2011, Walter R.P. Novak
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.


import os
import string
import sys


###############################################################################
# Retrieves the name of the input file from the command line, or if the file is
# not specified, prints an error message and exits the program
###############################################################################
def getInFileNames(argv):

  errorString = "Usage: pdb_mod2chain.py <inputFile>"

  if len(argv) < 2:
    print errorString
    sys.exit(0)
  else:
    inFileName = argv[1]

  return inFileName

###############################################################################
def chainit(inFileName):

  alpha = "0ABCDEFGHIJKLMNOPQRSTUVWXYZ"
  inFile = open(inFileName, "r")
  out = "%s.chains" % (inFileName) 
  outFile = open(out, "w")

  print """
    ###############################################################
    pdb_model2chain.py  Copyright (C) 2011 Walter R.P. Novak
    This program comes with ABSOLUTELY NO WARRANTY.
    This is free software, and you are welcome to redistribute it
    under certain conditions; view source code for details.
    ###############################################################"""

  while 1:
    line = inFile.readline()
    if not line: break
    try: 
      first = string.split(line)[0]
    except: 
      continue  
    if first == "MODEL":
      second = string.split(line)[1]
      secint = int(second)
      #print "this is model 1 and the %s  chain.\n" % alpha[secint]
      continue
    elif line[:4] == "ATOM":
      lastline = line
      outFile.write(line[:21] + alpha[secint] + line[22:])
    elif line[:6] == "HETATM":
      lastline = line
      outFile.write(line[:21] + alpha[secint] + line[22:])
    elif first == "ENDMDL":
      lastline = lastline[:21] + alpha[secint] + lastline[22:26]
      serial = str(int(lastline[6:11]) + 1)
      while len(serial) < 5:
        serial = " " + serial
      
      #print lastline
      ter = "TER   " + serial + "      " + lastline[17:] + "\n"
      #print ter 
      outFile.write(ter)



    else: outFile.write(line)


  outFile.close()
  print "\n Your output file %s has been written.\n" % out

  

###############################################################################
# Main program
###############################################################################
def pdb_model2chain(argv):

  inFileName = getInFileNames(argv)

  chainit(inFileName)

pdb_model2chain(sys.argv)












